<template>
  <page
    class="flex-grow-1"
    id="find_station"
    title="Leitores"
  >
    <v-list two-line="two-line">
      <v-list-item v-if="!stations || stations.length === 0">
        <v-list-item-content>
          <v-list-item-title>No results found!</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <v-list-item
        v-else
        v-for="station in stations"
        :key="station.id"
      >
        <v-list-item-content>
          <v-list-item-title>{{station.node}}</v-list-item-title>
          <v-list-item-subtitle>{{station.person && station.person.fullname}}</v-list-item-subtitle>
        </v-list-item-content>
        <v-list-item-action>
          <v-btn
            icon="icon"
            @click="$router.push({ name: 'station', params: { id: station.id } })"
          >
            <v-icon>mdi-information</v-icon>
          </v-btn>
        </v-list-item-action>
      </v-list-item>
    </v-list>
  </page>
</template>

<script lang="ts">
import Vue from 'vue'

import Page from '@/components/Page.vue'

import listStationsQuery from '@/gql/StationList.gql'
import listStationsSubscription from '@/gql/StationListSubscription.gql'

export default Vue.extend({
  name: 'StationsPage',
  components: { Page },
  apollo: {
    stations: {
      query: listStationsQuery,
      subscribeToMore: {
        document: listStationsSubscription,
        updateQuery: (previousResult, { subscriptionData }) => {
          return subscriptionData.data
        }
      }
    }
  }

})
</script>
